Get2ConcurrentBoundedBuffer subclass: #ASCGet2BoundedBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-ASC-Examples'!


!ASCGet2BoundedBuffer methodsFor: 'state predicates'!

isOne
	^(putIndex - 1) = (getIndex \\ array size)! !

!ASCGet2BoundedBuffer methodsFor: 'default classes'!

activityClass
	"The ASC-based associated specification."

	^Get2BoundedBufferASCActivity! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ASCGet2BoundedBuffer class
	instanceVariableNames: ''!


!ASCGet2BoundedBuffer class methodsFor: 'example'!

exampleGet2Size: maxSize numberItems: numberItems speedRatio: ratio
	"self exampleGet2Size: 3 numberItems: 8 speedRatio: 2"

	super exampleGet2Size: maxSize numberItems: numberItems speedRatio: ratio! !

ConcurrentBoundedBuffer subclass: #ASCBoundedBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-ASC-Examples'!


!ASCBoundedBuffer methodsFor: 'state predicates'!

isEmpty
	^getIndex = putIndex!

isFull
	^(putIndex \\ array size) = (getIndex - 1)! !

!ASCBoundedBuffer methodsFor: 'default classes'!

activityClass
	"The ASC-based associated specification."

	^BoundedBufferASCActivity! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ASCBoundedBuffer class
	instanceVariableNames: ''!


!ASCBoundedBuffer class methodsFor: 'example'!

exampleSize: maxSize numberItems: numberItems speedRatio: ratio
	"self exampleSize: 3 numberItems: 8 speedRatio: 4"
	"self exampleSize: 3 numberItems: 8 speedRatio: 1/4"

	super exampleSize: maxSize numberItems: numberItems speedRatio: ratio! !

ASCActivity subclass: #BoundedBufferASCActivity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-ASC-Examples'!


!BoundedBufferASCActivity methodsFor: 'abstract states'!

empty
	^#(put:)!

full
	^#(get)!

initialAbstractState
	^#empty!

partial
	"Note that we use union of sets (in fact concatenation of arrays) for better modularity.
	See class Get2BoundedBufferASCActivity redefinition of #full,
	and consequently implicit redefinition of #partial."

	^(self empty) + (self full)! !

!BoundedBufferASCActivity methodsFor: 'state transition'!

nextAbstractStateAfter: selector
	^oself isEmpty
		ifTrue: [#empty]
		ifFalse: [oself isFull
					ifTrue: [#full]
					ifFalse: [#partial]]! !

!BoundedBufferASCActivity methodsFor: 'guards'!

guardOFget
	"Only one get at once."

	^(self current: #get) = 0!

guardOFput: item
	"Only one put at once."

	^(self current: #put:) = 0! !

BoundedBufferASCActivity subclass: #Get2BoundedBufferASCActivity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-ASC-Examples'!


!Get2BoundedBufferASCActivity methodsFor: 'abstract states'!

full
	^(super full) + #(get2)!

one
	^(self partial) - #(get2)

	"Note that an alternative is: (self empty) + #(get)."! !

!Get2BoundedBufferASCActivity methodsFor: 'state transition'!

nextAbstractStateAfter: selector
	^oself isOne
		ifTrue: [#one]
		ifFalse: [super nextAbstractStateAfter: selector]! !

!Get2BoundedBufferASCActivity methodsFor: 'guards'!

guardOFget
	"Like before, plus no get2."

	^super guardOFget
		and: [(self current: #get2) = 0]!

guardOFget2
	"As for get"

	^self guardOFget! !

BoundedBufferASCActivity subclass: #GetRear2BoundedBufferASCActivity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-ASC-Examples'!


!GetRear2BoundedBufferASCActivity methodsFor: 'abstract states'!

full
	^(super full) + #(getRear)!

one
	^(self partial) - #(getRear)! !

!GetRear2BoundedBufferASCActivity methodsFor: 'state transition'!

nextAbstractStateAfter: selector
	^self isOne
		ifTrue: [#one]
		ifFalse: [super nextAbstractStateAfter: selector]! !

!GetRear2BoundedBufferASCActivity methodsFor: 'guards'!

guardOFgetRear
	"As for put:."

	^self guardOFput: #dummy!

guardOFput: item
	"As before, plus no getRear."

	^(super guardOFput: item)
		and: [(self current: #getRear) = 0]! !

BoundedBufferASCActivity subclass: #GetRearBoundedBufferASCActivity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-ASC-Examples'!


!GetRearBoundedBufferASCActivity methodsFor: 'abstract states'!

full
	^(super full) + #(getRear)! !

!GetRearBoundedBufferASCActivity methodsFor: 'guards'!

guardOFget
	"As for get, plus no getRear because we make no assumption that there are at least two elements."

	^super guardOFget
		and: [(self current: #getRear) = 0]!

guardOFgetRear
	"GetRear excludes all methods.
	Restrict get and getRear concurrency because we make no assumption if there are at least two elements."

	^(self current: #getRear) = 0
		and: [(self current: #get) = 0
				and: [(self current: #put:) = 0]]!

guardOFput: item
	"As for put, plus no getRear."

	^(super guardOFput: item)
		and: [(self current: #getRear) = 0]! !

GetRearConcurrentBoundedBuffer subclass: #ASCGetRearBoundedBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-ASC-Examples'!


!ASCGetRearBoundedBuffer methodsFor: 'default classes'!

activityClass
	"The ASC-based associated specification."

	^GetRearBoundedBufferASCActivity! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ASCGetRearBoundedBuffer class
	instanceVariableNames: ''!


!ASCGetRearBoundedBuffer class methodsFor: 'example'!

exampleGetRearSize: maxSize numberItems: numberItems speedRatio: ratio
	"self exampleGetRearSize: 3 numberItems: 8 speedRatio: 1"

	super exampleGetRearSize: maxSize numberItems: numberItems speedRatio: ratio! !

GetRearConcurrentBoundedBuffer subclass: #ASCGetRear2BoundedBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-ASC-Examples'!


!ASCGetRear2BoundedBuffer methodsFor: 'state predicates'!

isOne
	^(putIndex - 1) = (getIndex \\ array size)! !

!ASCGetRear2BoundedBuffer methodsFor: 'default classes'!

activityClass
	"The ASC-based associated specification."

	^GetRear2BoundedBufferASCActivity! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ASCGetRear2BoundedBuffer class
	instanceVariableNames: ''!


!ASCGetRear2BoundedBuffer class methodsFor: 'example'!

exampleGetRearSize: maxSize numberItems: numberItems speedRatio: ratio
	"self exampleGetRearSize: 3 numberItems: 8 speedRatio: 1"

	super exampleGetRearSize: maxSize numberItems: numberItems speedRatio: ratio! !
