ActivationActivity subclass: #PrinterActivity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-Activation-Ex'!


!PrinterActivity methodsFor: 'guards'!

guardOFprint: job length: length
	^(self current: #print:length:) = 0
		and: [self noActivationWith: [:activation |
					activation selector = #print:length:
						and: [(activation arguments at: 2) < length]]]! !

PrinterActivity subclass: #PrinterActivity2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-Activation-Ex'!


!PrinterActivity2 methodsFor: 'guards'!

guardOFprint: job length: length
	^(self current: #print:length:) = 0
		and: [self noActivationWith: [:activation |
					activation length < length]]! !

!PrinterActivity2 methodsFor: 'synchro events'!

synchroEventReceive: anActivation
	super synchroEventReceive: anActivation.
	anActivation length: (anActivation arguments at: 2)!

synchroReceiveEvent: anActivation
	super synchroReceiveEvent: anActivation.
	anActivation length: (anActivation arguments at: 2)! !

!PrinterActivity2 methodsFor: 'default classes'!

activationClass
	^LengthActivation! !

ConcurrentBoundedBuffer subclass: #ActivationBoundedBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-Activation-Ex'!


!ActivationBoundedBuffer methodsFor: 'accessing'!

maxSize
	^maxSize! !

!ActivationBoundedBuffer methodsFor: 'default classes'!

activityClass
	^BoundedBufferActivationActivity! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ActivationBoundedBuffer class
	instanceVariableNames: ''!


!ActivationBoundedBuffer class methodsFor: 'example'!

exampleSize: maxSize numberItems: numberItems speedRatio: ratio
	"self exampleSize: 3 numberItems: 8 speedRatio: 2"

	super exampleSize: maxSize numberItems: numberItems speedRatio: ratio! !

Activation subclass: #LengthActivation
	instanceVariableNames: 'length '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-Activation-Ex'!


!LengthActivation methodsFor: 'accessing'!

length
	^length!

length: anInteger
	length := anInteger! !

ActivationActivity subclass: #BoundedBufferActivationActivity
	instanceVariableNames: 'maxSize '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-Activation-Ex'!


!BoundedBufferActivationActivity methodsFor: 'initialize'!

privateInitialize
	super privateInitialize.
	maxSize := oself maxSize! !

!BoundedBufferActivationActivity methodsFor: 'guards'!

guardOFget
	"Only one get at once and the buffer should be not empty.
	Also ensures message ordering preservation."

	^(self current: #get) = 0
		and: [((self completed: #put:) - (self completed: #get)) > 0
				and: [self messageOrderingPreservationFor: #get]]!

guardOFput: item
	"Only one put at once and the buffer should not be full.
	Also ensures message ordering preservation."

	^(self current: #put:) = 0
		and: [((self completed: #put:) - (self completed: #get)) < maxSize
				and: [self messageOrderingPreservationFor: #put:]]! !

ImplicitReplyObject subclass: #PrinterDevice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-Activation-Ex'!


!PrinterDevice methodsFor: 'script'!

print: job length: length
	Transcript show: 'Print job: ' , job printString , ' of length: ' , length printString; cr! !

!PrinterDevice methodsFor: 'default classes'!

activityClass
	^PrinterActivity! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PrinterDevice class
	instanceVariableNames: ''!


!PrinterDevice class methodsFor: 'example'!

example
	"self example"

	self new active
		print: 1 length: 60;
		print: 2 length: 20;
		print: 3 length: 30!

example2
	"self example2"

	(self new activity: PrinterActivity2 address: ActivationAddress)
		print: 1 length: 60;
		print: 2 length: 20;
		print: 3 length: 30! !
